#
# Copyright (c) 2015 Midokura SARL, All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
from charmhelpers.core import hookenv
from charmhelpers.core.services import base
from charmhelpers.core.services import helpers
import relations


class Config(dict):
    def __init__(self, *args):
        self['config'] = hookenv.config()


def manage():
    nova = relations.NovaRelation()
    config = Config()
    manager = base.ServiceManager([
        {
            'service': 'neutron-dhcp-agent',
            'required_data': [],
            'data_ready': [
                helpers.render_template(
                    source='dhcp_agent.ini',
                    target='/etc/neutron/dhcp_agent.ini'),
            ],
        },
        {
            'service': 'neutron-metadata-agent',
            'required_data': [Config(),
                              nova],
            'data_ready': [
                helpers.render_template(
                    source='metadata_agent.ini',
                    target='/etc/neutron/metadata_agent.ini'),
            ],
        },
    ])
    manager.manage()
